#ifndef __SYSAPI__
#define __SYSAPI__
#include <glibtop/mem.h>
#include <glibtop/swap.h>
#include <glibtop/netload.h>
#include <glibtop/netlist.h>

class SysApi
{
public:
	/* CPU占用率获取接口 */
    virtual double percent_cpu()= 0;

	/* 内存占用率获取接口 */
    virtual double update_mem() = 0;

 virtual guint64 get_swap_total(void) = 0;
  virtual guint64 get_swap_used(void) = 0;

	/* 网络收发情况接口 */
    virtual guint64 get_net_in_total(void) = 0;
    virtual guint64 get_net_out_total(void) = 0;
    virtual guint64 get_net_din(void) = 0;
    virtual guint64 get_net_dout(void) = 0;
    virtual void update_net_info(void) = 0;

	/* 存储使用率（总量及用量）获取接口 */
	virtual double get_emmc_percent() = 0;
	virtual int cal_mmcsize() = 0;
        virtual __u64 get_emmc_total_size()  = 0;
        virtual __u64 get_emmc_used_size() = 0;
        virtual __u64 get_emmc_available_size() = 0;


	/* 电池用电量（预计可持续工作时间） */
	virtual int get_battery_capacity() = 0;
	virtual float get_battery_time_to_empty() = 0;

	/* 检查CPU是否正常工作 */
    virtual int check_cpu(void) = 0;

	/* 检查内存是否正常工作 */
	virtual int check_mem(void) = 0;

	/* 检测网卡是否正常工作 */
	virtual int check_net(void) = 0;

	/* 检测电池是否正常工作 */
	virtual int check_batpresent() = 0;

	/* 检测硬盘是否正常工作 */
	virtual int check_mmc()     = 0 ;

	/* 检测屏幕是否正常工作 */
	virtual int check_lcd()     = 0;

	/* emmc 容量告警 （> %90) */
	virtual int check_mmc_full() = 0;

	/* 检查音频芯片es8316 */
        virtual int check_es8316() = 0;

	/* 检查充电芯片*/
        virtual int check_charging_chip() = 0;

	/* 检查电池电量计*/
        virtual int check_battery_fuel_gauge() = 0;

	/* 检查aw21024_led*/
        virtual int check_aw21024_led() = 0;

	/* 检查屏幕转接芯片*/
        virtual int check_screen_chip() = 0;

	/* 检查触摸屏*/
        virtual int check_toucscreen_id() = 0;

	/* 高温报警*/
        virtual int check_cpu0_temp() = 0;

};

#endif // IXRDBMANAGER_H
