#ifndef __SYSCHECK__
#define __SYSCHECK__

#include <SysInfo.h>
#include <sys/stat.h>
#include <linux/fb.h>
#include <sys/ioctl.h>
#include <random>
using Random=std::default_random_engine;
#include <string>
using std::string;
#include <set>
using std::set;
#include <algorithm>
using std::insert_iterator;
using std::set_difference;

enum ERR_CODE{
     CPU_ERR = 1,
     MEM_ERR,
     NET_ERR_NO_PHY_APT,
     NET_ERR_NO_VALID_CON,
     EMMC_RW_ERR,
     EMMC_FULL_ERR,
     BATT_ERR,
     LCD_ERR,
    CPU_TEMP_ERR
};

class SysCheck : public SysInfo 
{
public:
    SysCheck();
	~SysCheck();
    int check_cpu(void);
    int check_mem(void);
    int check_net(void); //check network apdater

    /* emmc 容量告警 （> %90) */
    int check_mmc_full()
    {
	if(get_emmc_percent()*100 > 90){
	   return EMMC_FULL_ERR;
	  }
	else return 0;
    }

    /* emmc 读写检测告警 */
    int check_mmc();

    /* 屏幕运行告警 */
    int check_lcd();

    /* 电池运行告警  */
    int check_batpresent();

    int check_es8316();
    int check_charging_chip();
    int check_battery_fuel_gauge();
    int check_aw21024_led();
    int check_screen_chip();
    int check_toucscreen_id();
    int check_cpu0_temp();

private:
    int check_cpu_core(int c);
    bool check_apt_con(const string &apt);

};


#endif

