#ifndef __SYSINFO__
#define __SYSINFO__
#include "SysApi.h"
#include <fcntl.h>
#include <unistd.h>
#define BATTERY_CHARGING_STATUS_PATH  "/sys/class/power_supply/cw2017-bat/status"
#define BATTERY_TIME_TO_EMPTY_PATH  "/sys/class/power_supply/cw2017-bat/time_to_empty_now"
#define BATTERY_PRESENT  "/sys/class/power_supply/cw2217/present"
#define BATTERY_AC_ONLINE "/sys/class/power_supply/bq24735@2-0009/online"
#define READ_BATTERY_CAPACITY   "cat /sys/class/power_supply/cw2017-bat/capacity > /tmp/battery_capacity.txt"
#define BATTERY_CAPACITY_PATH         "/sys/class/power_supply/cw2017-bat/capacity"
#define qlog printf
typedef unsigned long long __u64;

struct mmc_size_info{
	__u64 total_size;
	__u64 used_size;
	__u64 available_size;
	unsigned int percentage=0;
};

class SysInfo :public SysApi
{
public:
    SysInfo(void);
	~SysInfo();
    void update_net_info(void);
    //mem info
    void update_mem_info(void) {
		glibtop_get_mem(&_mem);
	}
    guint64 get_mem_total(void) {
		return _mem.total;
	}
    guint64 get_mem_used(void) {
		return _mem.user;
	}
    //swap_info
    guint64 get_swap_total(void) {
		return _swap.total;
	}
    guint64 get_swap_used(void) {
		return _swap.used;
	}
    //net info
    guint64 get_net_in_total(void) {
		return last_in;
	}
    guint64 get_net_out_total(void) {
		return last_out;
	}
    guint64 get_net_din(void) {
		return din;
	}
    guint64 get_net_dout(void) {
		return dout;
	}
	double update_mem(){
		update_mem_info();
		return (get_mem_used()*100.00/get_mem_total());
	}

	/* 计算CPU百分比 */
	double percent_cpu();

	/* 获取emmc 总容量(Byte) */
	__u64 get_emmc_total_size();
	__u64 get_emmc_used_size();
	__u64 get_emmc_available_size();

	/* 获取emmc 使用占比(%) */
	double get_emmc_percent();
	int cal_mmcsize();

	/* 获取电池电量百分比（%）*/
	int get_battery_capacity();

	/* 获取预计可持续工作时间(h) */
	float get_battery_time_to_empty();
	int get_battery_ac_online();


private:
	unsigned long long getCpuTimeData(unsigned long long &workTime);
	mmc_size_info mmcsize;
    glibtop_mem _mem;
    glibtop_swap _swap;
    guint64 last_in, last_out, din, dout; //net count
    GTimeVal last_time; //net update time
    unsigned long long cpuworkTime, prevCpuWorkTime, cpuTotalTime, prevCpuTotalTime;

	int getshelldata(const char *cmd, char* buffer);
};

#endif
